#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_exportasdm import exportasdm
from task_exportasdm import casalog

class exportasdm_pg_:
    __name__ = "exportasdm"

    def __init__(self) :
       self.__bases__ = (exportasdm_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,asdm=None,datacolumn=None,archiveid=None,rangeid=None,subscanduration=None,sbduration=None,apcorrected=None,verbose=None,showversion=None,useversion=None,):

        """Convert a CASA visibility file (MS) into an ALMA or EVLA Science Data Model

  exportasdm(vis='ngc4826.ms', asdm='uid___S021_X1418_X1', 
             datacolumn='corrected', archiveid='S021', rangeid='X1418', 
             verbose=False)
  will produce an ASDM named 'uid___S021_X1418_X1' using the 
  datacolumn 'corrected' in the MS 'ngc4826.ms' with minimal
  log output. 

  The sbduration parameter controls the number of execution blocks (EBs)
  into which exportasdm subdivides the visibilities from your input MS.
  If the total observation time in the MS is shorter than what is given 
  in sbduration, a single EB will be created.

  Note concerning ALMA data: exportasdm presently is not able to export 
  from MSs containing WVR data. If you attempt to export such an MS, you
  will receive an error message saying that you can only export data of
  processor type "CORRELATOR". It will also give you the list of SPWs
  which contain CORRELATOR data. You will then have to split out these
  SPWs using the task "split" and run exportasdm on the resulting MS. 

  Also EVLA data can be exported. Note here that exportasdm does not produce
  online flags and that a subsequent reimport of the data must be done with
  online=False. Also, importevla will only work on your ASDM if you have 
  exported it with apcorrected=False (the default).

   importevla('xosrosdm', vis = 'xosro.ms')
   exportasdm(vis='xosro.ms', asdm='xosrosdm', apcorrected=False)
   importevla(asdm='xosro2asdm', vis='xosro2-reimp.ms', online=False)

  
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'exportasdm'
        myf['taskname'] = 'exportasdm'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['asdm'] = asdm = myf['asdm']
            myparams['datacolumn'] = datacolumn = myf['datacolumn']
            myparams['archiveid'] = archiveid = myf['archiveid']
            myparams['rangeid'] = rangeid = myf['rangeid']
            myparams['subscanduration'] = subscanduration = myf['subscanduration']
            myparams['sbduration'] = sbduration = myf['sbduration']
            myparams['apcorrected'] = apcorrected = myf['apcorrected']
            myparams['verbose'] = verbose = myf['verbose']
            myparams['showversion'] = showversion = myf['showversion']
            myparams['useversion'] = useversion = myf['useversion']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['asdm'] = asdm
        mytmp['datacolumn'] = datacolumn
        mytmp['archiveid'] = archiveid
        mytmp['rangeid'] = rangeid
        mytmp['subscanduration'] = subscanduration
        mytmp['sbduration'] = sbduration
        mytmp['apcorrected'] = apcorrected
        mytmp['verbose'] = verbose
        mytmp['showversion'] = showversion
        mytmp['useversion'] = useversion
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'exportasdm.xml')

        casalog.origin('exportasdm')
        if not trec.has_key('exportasdm') or not casac.utils().verify(mytmp, trec['exportasdm']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: exportasdm           #####')
          casalog.post('')
          result = exportasdm(vis, asdm, datacolumn, archiveid, rangeid, subscanduration, sbduration, apcorrected, verbose, showversion, useversion)
          casalog.post('')
          casalog.post('##### End Task: exportasdm           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('exportasdm', 'exportasdm.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'exportasdm'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('exportasdm', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['vis']  = ''
        a['asdm']  = ''
        a['datacolumn']  = 'data'
        a['archiveid']  = 'S0'
        a['rangeid']  = 'X1'
        a['subscanduration']  = '24h'
        a['sbduration']  = '2700s'
        a['apcorrected']  = False
        a['verbose']  = True
        a['showversion']  = True
        a['useversion']  = 'v3'


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='exportasdm', subkey=None):
        desc={'exportasdm': 'Convert a CASA visibility file (MS) into an ALMA or EVLA Science Data Model',
               'vis': 'MS name',
               'asdm': 'Name of output ASDM directory (on disk)',
               'datacolumn': 'specifies which MS data column is used to fill the visibilites in the ASDM',
               'archiveid': 'the X0 in uid://X0/X1/X<running>',
               'rangeid': 'the X1 in uid://X0/X1/X<running>',
               'subscanduration': 'maximum duration of a subscan in the output ASDM',
               'sbduration': 'maximum duration of a scheduling block (and therefore exec block) in the output ASDM',
               'apcorrected': 'data to be marked as having atmospheric phase correction',
               'verbose': 'produce log output',
               'showversion': 'Report the version of ASDM class set being used',
               'useversion': 'Selects the version of MS2asdm to be used (\'v3\' (default and only option presently))',

              }

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['asdm']  = ''
        a['datacolumn']  = 'data'
        a['archiveid']  = 'S0'
        a['rangeid']  = 'X1'
        a['subscanduration']  = '24h'
        a['sbduration']  = '2700s'
        a['apcorrected']  = False
        a['verbose']  = True
        a['showversion']  = True
        a['useversion']  = 'v3'

        if a.has_key(paramname) :
	      return a[paramname]
exportasdm_pg = exportasdm_pg_()
