#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_plotbandpass import plotbandpass
from task_plotbandpass import casalog

class plotbandpass_pg_:
    __name__ = "plotbandpass"

    def __init__(self) :
       self.__bases__ = (plotbandpass_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, caltable=None,antenna=None,field=None,spw=None,yaxis=None,xaxis=None,figfile=None,plotrange=None,caltable2=None,overlay=None,showflagged=None,timeranges=None,buildpdf=None,caltable3=None,markersize=None,density=None,interactive=None,showpoints=None,showlines=None,subplot=None,zoom=None,poln=None,showatm=None,pwv=None,gs=None,convert=None,chanrange=None,solutionTimeThresholdSeconds=None,debug=None,phase=None,vis=None,showtsky=None,showfdm=None,showatmfield=None,lo1=None,showimage=None,showatmpoints=None,parentms=None,pdftk=None,channeldiff=None,edge=None,resample=None,platformingThreshold=None,platformingSigma=None,basebands=None,showBasebandNumber=None,scans=None,figfileSequential=None,chanrangeSetXrange=None,):

        """Makes detailed plots of Tsys and bandpass solutions.

plotbandpass('X3c1.tsys',overlay='antenna',yaxis='amp',field='0~1,4',xaxis='chan',figfile='tsys.png')

plotbandpass('bandpass.bcal',caltable2='bandpass.bcal_smooth',xaxis='freq')  

plotbandpass('bandpass.bcal',caltable2='bandpass.bcal_smooth',xaxis='freq',poln='X',showatm=T)

plotbandpass('bandpass.bcal',channeldiff='5')

This task returns void unless the channeldiff option is selected, in which case it returns a
dictionary containing the statistics of the solutions, keyed by the antenna name, followed
by the spw, timerange, polarization, and finally 'amp' and/or 'phase' depending
on the yaxis selection.  

   Keyword arguments:

 antenna: must be either an ID (int or string or list), or a single antenna name or list
 basebands: show only spws from the specified baseband or list of basebands (default: ''=[]=all)
 buildpdf: True/False, if True and figfile is set, assemble pngs into a pdf
 caltable: a bandpass table, of type B or BPOLY
 caltable2: a second cal table, of type BPOLY or B, to overlay on a B table
 caltable3: a third cal table, of type BPOLY, to overlay on the first two
 channeldiff: set to value > 0 to plot derivatives of amplitude, the value is also used as sigma, and any outliers beyond this sigma will be printed to the logger
 chanrange: set xrange (e.g. "5~100") over which to autoscale y-axis for xaxis='freq'
 chanrangeSetXrange: if True, then chanrange also sets the xrange to display
 convert: full path for convert command (in case it's not found)
 density: dpi to use in creating PNGs and PDFs (default=108)
 edge: the number of edge channels to ignore in finding outliers (for channeldiff>0)
 field: must be an ID, source name, or list thereof; can use trailing *: 'J*'
 figfile: the base_name of the png files to save: base_name.antX.spwY.png
 figfileSequential: naming scheme, False: name by spw/antenna (default)
                    True: figfile.1.png, figfile.2.png, etc.
 gs: full path for ghostscript command (in case it's not found)
 interactive: if False, then figfile will run to completion automatically
 lo1: specify the LO1 setting (in GHz) for the observation
 overlay: 'antenna','time','spw', or 'baseband', make 1 plot with different items in colors
 markersize: size of points (default=3)
 ms: name of the ms for this table, in case it does not match the string in the caltable
 parentms: name of the parent ms, in case the ms has been previously split
 pdftk: full path for pdftk command (in case it's not found)
 phase: the y-axis limits to use for phase plots when yaxis='both'
 platformingSigma: declare platforming if the amplitude derivative exceeds this many times the MAD
 platformingThreshold: if platformingSigma=0, then declare platforming if the amplitude
                       derivative exceeds this percentage of the median
 plotrange: define axis limits: [x0,x1,y0,y1] where 0,0 means auto
 poln: polarizations to plot (e.g. 'XX','YY','RR','LL' or '' for both)
 pwv: define the pwv to use for the showatm option: 'auto' or value in mm
 resample: channel expansion factor to use when computing MAD of derivative (for channeldiff>0)
 scans: show only solutions for the specified scans (int, list, or string)
 showatm: compute and overlay the atmospheric transmission curve (on B or Tsys solutions)
 showatmfield: use first observation of this fieldID or name
 showatmPoints: draw atmospheric curve with points instead of a line
 showBasebandNumber: put the BBC_NO in the title of each plot
 showfdm: when showing TDM spws with xaxis='freq', draw locations of FDM spws
 showflagged:  show the values of data, even if flagged
 showimage: also show the atmospheric curve for the image sideband (in black)
 showtsky: compute and overlay the sky temperature curve instead of transmission
 showlines: draw lines connecting the data (default=T for amp, F for phase)
 showpoints: draw points for the data (default=F for amp, T for phase)
 solutionTimeThresholdSeconds: consider 2 solutions simultaneous if within this interval (default=60)
 spw: must be single ID or list or range (e.g. 0~4, not the original ID)
 subplot: 11..81,22,32 or 42 for RowsxColumns (default=22), any 3rd digit is ignored
 timeranges: show only these timeranges, the first timerange being 0
 xaxis: 'chan' or 'freq'
 yaxis: 'amp', 'tsys', 'phase', or 'both' amp+phase == 'ap'. Append 'db' for dB
 zoom: 'intersect' will zoom to overlap region of caltable with caltable2

  
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'plotbandpass'
        myf['taskname'] = 'plotbandpass'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['caltable'] = caltable = myf['caltable']
            myparams['antenna'] = antenna = myf['antenna']
            myparams['field'] = field = myf['field']
            myparams['spw'] = spw = myf['spw']
            myparams['yaxis'] = yaxis = myf['yaxis']
            myparams['xaxis'] = xaxis = myf['xaxis']
            myparams['figfile'] = figfile = myf['figfile']
            myparams['plotrange'] = plotrange = myf['plotrange']
            myparams['caltable2'] = caltable2 = myf['caltable2']
            myparams['overlay'] = overlay = myf['overlay']
            myparams['showflagged'] = showflagged = myf['showflagged']
            myparams['timeranges'] = timeranges = myf['timeranges']
            myparams['buildpdf'] = buildpdf = myf['buildpdf']
            myparams['caltable3'] = caltable3 = myf['caltable3']
            myparams['markersize'] = markersize = myf['markersize']
            myparams['density'] = density = myf['density']
            myparams['interactive'] = interactive = myf['interactive']
            myparams['showpoints'] = showpoints = myf['showpoints']
            myparams['showlines'] = showlines = myf['showlines']
            myparams['subplot'] = subplot = myf['subplot']
            myparams['zoom'] = zoom = myf['zoom']
            myparams['poln'] = poln = myf['poln']
            myparams['showatm'] = showatm = myf['showatm']
            myparams['pwv'] = pwv = myf['pwv']
            myparams['gs'] = gs = myf['gs']
            myparams['convert'] = convert = myf['convert']
            myparams['chanrange'] = chanrange = myf['chanrange']
            myparams['solutionTimeThresholdSeconds'] = solutionTimeThresholdSeconds = myf['solutionTimeThresholdSeconds']
            myparams['debug'] = debug = myf['debug']
            myparams['phase'] = phase = myf['phase']
            myparams['vis'] = vis = myf['vis']
            myparams['showtsky'] = showtsky = myf['showtsky']
            myparams['showfdm'] = showfdm = myf['showfdm']
            myparams['showatmfield'] = showatmfield = myf['showatmfield']
            myparams['lo1'] = lo1 = myf['lo1']
            myparams['showimage'] = showimage = myf['showimage']
            myparams['showatmpoints'] = showatmpoints = myf['showatmpoints']
            myparams['parentms'] = parentms = myf['parentms']
            myparams['pdftk'] = pdftk = myf['pdftk']
            myparams['channeldiff'] = channeldiff = myf['channeldiff']
            myparams['edge'] = edge = myf['edge']
            myparams['resample'] = resample = myf['resample']
            myparams['platformingThreshold'] = platformingThreshold = myf['platformingThreshold']
            myparams['platformingSigma'] = platformingSigma = myf['platformingSigma']
            myparams['basebands'] = basebands = myf['basebands']
            myparams['showBasebandNumber'] = showBasebandNumber = myf['showBasebandNumber']
            myparams['scans'] = scans = myf['scans']
            myparams['figfileSequential'] = figfileSequential = myf['figfileSequential']
            myparams['chanrangeSetXrange'] = chanrangeSetXrange = myf['chanrangeSetXrange']

        if type(plotrange)==float: plotrange=[plotrange]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['caltable'] = caltable
        mytmp['antenna'] = antenna
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['yaxis'] = yaxis
        mytmp['xaxis'] = xaxis
        mytmp['figfile'] = figfile
        mytmp['plotrange'] = plotrange
        mytmp['caltable2'] = caltable2
        mytmp['overlay'] = overlay
        mytmp['showflagged'] = showflagged
        mytmp['timeranges'] = timeranges
        mytmp['buildpdf'] = buildpdf
        mytmp['caltable3'] = caltable3
        mytmp['markersize'] = markersize
        mytmp['density'] = density
        mytmp['interactive'] = interactive
        mytmp['showpoints'] = showpoints
        mytmp['showlines'] = showlines
        mytmp['subplot'] = subplot
        mytmp['zoom'] = zoom
        mytmp['poln'] = poln
        mytmp['showatm'] = showatm
        mytmp['pwv'] = pwv
        mytmp['gs'] = gs
        mytmp['convert'] = convert
        mytmp['chanrange'] = chanrange
        mytmp['solutionTimeThresholdSeconds'] = solutionTimeThresholdSeconds
        mytmp['debug'] = debug
        mytmp['phase'] = phase
        mytmp['vis'] = vis
        mytmp['showtsky'] = showtsky
        mytmp['showfdm'] = showfdm
        mytmp['showatmfield'] = showatmfield
        mytmp['lo1'] = lo1
        mytmp['showimage'] = showimage
        mytmp['showatmpoints'] = showatmpoints
        mytmp['parentms'] = parentms
        mytmp['pdftk'] = pdftk
        mytmp['channeldiff'] = channeldiff
        mytmp['edge'] = edge
        mytmp['resample'] = resample
        mytmp['platformingThreshold'] = platformingThreshold
        mytmp['platformingSigma'] = platformingSigma
        mytmp['basebands'] = basebands
        mytmp['showBasebandNumber'] = showBasebandNumber
        mytmp['scans'] = scans
        mytmp['figfileSequential'] = figfileSequential
        mytmp['chanrangeSetXrange'] = chanrangeSetXrange
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'plotbandpass.xml')

        casalog.origin('plotbandpass')
        if not trec.has_key('plotbandpass') or not casac.utils().verify(mytmp, trec['plotbandpass']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: plotbandpass           #####')
          casalog.post('')
          result = plotbandpass(caltable, antenna, field, spw, yaxis, xaxis, figfile, plotrange, caltable2, overlay, showflagged, timeranges, buildpdf, caltable3, markersize, density, interactive, showpoints, showlines, subplot, zoom, poln, showatm, pwv, gs, convert, chanrange, solutionTimeThresholdSeconds, debug, phase, vis, showtsky, showfdm, showatmfield, lo1, showimage, showatmpoints, parentms, pdftk, channeldiff, edge, resample, platformingThreshold, platformingSigma, basebands, showBasebandNumber, scans, figfileSequential, chanrangeSetXrange)
          casalog.post('')
          casalog.post('##### End Task: plotbandpass           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('plotbandpass', 'plotbandpass.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'plotbandpass'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('plotbandpass', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['caltable']  = ''
        a['antenna']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['yaxis']  = 'amp'
        a['xaxis']  = 'chan'
        a['figfile']  = ''
        a['plotrange']  = [0,0,0,0]
        a['caltable2']  = ''
        a['overlay']  = ''
        a['showflagged']  = False
        a['timeranges']  = ''
        a['markersize']  = 3
        a['interactive']  = True
        a['showpoints']  = 'auto'
        a['showlines']  = 'auto'
        a['subplot']  = '22'
        a['poln']  = ''
        a['showatm']  = False
        a['solutionTimeThresholdSeconds']  = 30.0
        a['debug']  = False
        a['vis']  = ''
        a['showtsky']  = False
        a['channeldiff']  = False
        a['basebands']  = ''
        a['showBasebandNumber']  = False
        a['scans']  = ''
        a['figfileSequential']  = False

        a['figfile'] = {
                    0:odict([{'notvalue':''}, {'density':108}, {'buildpdf':False}, {'convert':'convert'}, {'gs':'gs'}, {'pdftk':'pdftk'}])}
        a['showatm'] = {
                    0:odict([{'notvalue':False}, {'pwv':'auto'}, {'showimage':False}, {'parentms':''}, {'lo1':''}, {'showatmpoints':False}])}
        a['showtsky'] = {
                    0:odict([{'notvalue':False}, {'pwv':'auto'}, {'showimage':False}, {'parentms':''}, {'lo1':''}, {'showatmpoints':False}])}
        a['xaxis'] = {
                    0:{'value':'chan'}, 
                    1:odict([{'value':'freq'}, {'chanrange':''}, {'showfdm':False}, {'chanrangeSetXrange':False}])}
        a['yaxis'] = {
                    0:{'value':'amp'}, 
                    1:odict([{'value':'both'}, {'phase':''}])}
        a['overlay'] = {
                    0:{'value':''}, 
                    1:odict([{'value':'time'}, {'showatmfield':''}])}
        a['channeldiff'] = {
                    0:odict([{'notvalue':False}, {'edge':8}, {'resample':1}, {'platformingSigma':5.0}, {'platformingThreshold':10.0}])}
        a['caltable2'] = {
                    0:odict([{'notvalue':''}, {'zoom':''}, {'caltable3':''}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='plotbandpass', subkey=None):
        desc={'plotbandpass': 'Makes detailed plots of Tsys and bandpass solutions.',
               'caltable': 'Input table name, either a bandpass solution or a Tsys solution',
               'antenna': 'A comma-delimited string list of antennas (either names or integer indices) for which to display solutions.  Default = all antennas.',
               'field': 'A comma-delimited string list of fields (either names or integer indices) for which to display solutions.  Default = all fields.',
               'spw': 'A comma-delimited string list of spws for which to display solutions.  Default = all spws.',
               'yaxis': 'The quantity to plot on the y-axis ("amp", "phase", "both", "tsys", append "db" for dB).',
               'xaxis': 'The quantity to plot on the x-axis ("chan" or "freq").',
               'figfile': 'The name of the plot file to produce.',
               'plotrange': 'The axes limits to use [x0,x1,y0,y1].',
               'caltable2': 'A second cal table, of type BPOLY or B, to overlay on a B table',
               'overlay': 'Show multiple solutions in same frame in different colors (time, antenna, spw, baseband, or time,antenna)',
               'showflagged': 'Show the values of the solution, even if flagged',
               'timeranges': 'Show only these timeranges, the first timerange being 0',
               'buildpdf': 'If True, assemble all the pngs into a pdf',
               'caltable3': 'A third cal table, of type BPOLY, to overlay on the first two tables',
               'markersize': 'Size of points',
               'density': 'dpi to use in creating PNGs and PDFs (default=108)',
               'interactive': 'if False, then run to completion automatically without pause',
               'showpoints': 'Draw points for the data (default=F for amp, T for phase)',
               'showlines': 'Draw lines connecting the data (default=T for amp, F for phase)',
               'subplot': '11..81,22,32 or 42 for RowsxColumns (default=22), any 3rd digit is ignored',
               'zoom': '"intersect" will zoom to overlap region of caltable with caltable2',
               'poln': 'Polarizations to plot: "" = all, or "RR","RL","LR","LL","XX","XY","YX","YY","RR,LL","XX,YY"',
               'showatm': 'Compute and overlay the atmospheric transmission curve',
               'pwv': 'Define the pwv to use for the showatm option: "auto" or value in mm',
               'gs': 'For buildpdf=T, full path for ghostscript command (in case it is not found)',
               'convert': 'For buildpdf=T, full path for the ImageMagick convert command (in case it is not found)',
               'chanrange': 'Set xrange ("5~100") over which to autoscale y-axis for xaxis="freq"',
               'solutionTimeThresholdSeconds': 'Consider 2 solutions simultaneous if within this interval in seconds',
               'debug': 'Print verbose messages for debugging purposes',
               'phase': 'The y-axis limits to use for phase plots when yaxis="both"',
               'vis': 'name of the ms for this table, in case it does not match the string in the caltable',
               'showtsky': 'Compute and overlay the sky temperature curve instead of transmission',
               'showfdm': 'when showing TDM spws, draw the locations of the corresponding FDM spws',
               'showatmfield': 'for overlay="time", use first observation of this fieldID or name',
               'lo1': 'specify the LO1 setting (in GHz) for the observation ('' = automatic)',
               'showimage': 'also show the atmospheric curve for the image sideband (in black)',
               'showatmpoints': 'Draw atmospheric curve with points instead of a line',
               'parentms': 'if showimage=T, name of the parent ms (only needed if the ms has been previously split)',
               'pdftk': 'For buildpdf=T, full path for pdftk command (in case it is not found)',
               'channeldiff': 'Set to a value > 0 (sigma) to plot derivatives of the solutions',
               'edge': 'The number of edge channels to ignore in finding outliers (for channeldiff>0)',
               'resample': 'The channel expansion factor to use when computing MAD of derivative (for channeldiff>0)',
               'platformingThreshold': 'if platformingSigma=0, then declare platforming if the amplitude derivative exceeds this percentage of the median',
               'platformingSigma': 'declare platforming if the amplitude derivative exceeds this many times the MAD',
               'basebands': 'A baseband number or list of baseband numbers for which to display solutions.  Default = all.',
               'showBasebandNumber': 'Put the baseband converter number (BBC_NO) in the title of each plot',
               'scans': 'A scan or list of scans for which to display solutions.  Default = all. Does not work with overlay="time".',
               'figfileSequential': 'naming scheme for pngs: False: name by spw/antenna (default), True: figfile.000.png, figfile.001.png, etc.',
               'chanrangeSetXrange': 'If True, then chanrange also sets the xrange to display',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['caltable']  = ''
        a['antenna']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['yaxis']  = 'amp'
        a['xaxis']  = 'chan'
        a['figfile']  = ''
        a['plotrange']  = [0,0,0,0]
        a['caltable2']  = ''
        a['overlay']  = ''
        a['showflagged']  = False
        a['timeranges']  = ''
        a['buildpdf']  = False
        a['caltable3']  = ''
        a['markersize']  = 3
        a['density']  = 108
        a['interactive']  = True
        a['showpoints']  = 'auto'
        a['showlines']  = 'auto'
        a['subplot']  = '22'
        a['zoom']  = ''
        a['poln']  = ''
        a['showatm']  = False
        a['pwv']  = 'auto'
        a['gs']  = 'gs'
        a['convert']  = 'convert'
        a['chanrange']  = ''
        a['solutionTimeThresholdSeconds']  = 30.0
        a['debug']  = False
        a['phase']  = ''
        a['vis']  = ''
        a['showtsky']  = False
        a['showfdm']  = False
        a['showatmfield']  = ''
        a['lo1']  = ''
        a['showimage']  = False
        a['showatmpoints']  = False
        a['parentms']  = ''
        a['pdftk']  = 'pdftk'
        a['channeldiff']  = False
        a['edge']  = 8
        a['resample']  = 1
        a['platformingThreshold']  = 10.0
        a['platformingSigma']  = 10.0
        a['basebands']  = ''
        a['showBasebandNumber']  = False
        a['scans']  = ''
        a['figfileSequential']  = False
        a['chanrangeSetXrange']  = False

        if a.has_key(paramname) :
	      return a[paramname]
plotbandpass_pg = plotbandpass_pg_()
