#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_plotuv import plotuv
from task_plotuv import casalog

class plotuv_pg_:
    __name__ = "plotuv"

    def __init__(self) :
       self.__bases__ = (plotuv_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,field=None,antenna=None,spw=None,observation=None,array=None,maxnpts=None,colors=None,symb=None,ncycles=None,figfile=None,):

        """Plot the baseline distribution
    Plots the uv coverage of vis in klambda.  ncycles of colors will be
    allocated to representative wavelengths.

    Keyword arguments:
      vis -- Name of input visibility file
             default: none; example: vis='ngc5921.ms'

      --- Data Selection (see help par.selectdata for more detailed
          information)

       field -- Select field using field id(s) or field name(s).
                 [run listobs to obtain the list IDs or names]
              default: ''=all fields.  If field is a non-negative
              integer, it is assumed to be a field index.
              Otherwise, it is assumed to be a field name
              field='0~2'; field ids 0,1,2
              field='0,4,5~7'; field ids 0,4,5,6,7
              field='3C286,3C295'; fields named 3C286 and 3C295
              field = '3,4C*'; field id 3, all names starting with 4C
        antenna -- Select data based on antenna/baseline
                default: '' (all)
                Non-negative integers are assumed to be antenna indices, and
                anything else is taken as an antenna name.

                Examples:
                antenna='5&6': baseline between antenna index 5 and index 6.
                antenna='VA05&VA06': baseline between VLA antenna 5 and 6.
                antenna='5&6;7&8': baselines 5-6 and 7-8
                antenna='5': all baselines with antenna 5
                antenna='5,6,10': all baselines including antennas 5, 6, or 10
                antenna='5,6,10&': all baselines with *only* antennas 5, 6, or
                                       10.  (cross-correlations only.  Use &&
                                       to include autocorrelations, and &&&
                                       to get only autocorrelations.)
                antenna='!ea03,ea12,ea17': all baselines except those that
                                           include EVLA antennas ea03, ea12, or
                                           ea17.
       spw -- Select spectral windows.  Channel selection is ignored for now.
              default: ''=all spectral windows
              spw='0~2,4'; spectral windows 0,1,2,4
              spw='<2';  spectral windows less than 2 (i.e. 0,1)
              spw='0'; spw 0
              spw='0,10,3'; spws 0, 10, and 3
       observation -- Select by observation ID(s). default: '' = all
       array -- (Sub)array number range. default: ''=all

      maxnpts -- Save memory and/or screen space by plotting a maximum of maxnpts
                 (or all of them if maxnpts < 1).  There is a very sharp
                 slowdown if the plotter starts swapping.
                 default: 100000
      colors -- a list of matplotlib color codes, used in order of decreasing
                visibility wavelength.
                default: ['r', 'y', 'g', 'b']  (red, yellow, green, blue)
      symb -- One of matplotlib's codes for plot symbols: .:,o^v<>s+xDd234hH|_
              default: ',':  The smallest points I could find.
      ncycles -- The number of times colors will be cycled through per plot.
                 default: 1
      figfile -- If not '', save the plots using names based on figfile.
                 Example: if figfile is 'test.png', and field is '1,2,4', the plots
		          will be saved to test_fld1.png, test_fld2.png,
			  and test_fld4.png.
                 default: '' (Do not save)
    
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'plotuv'
        myf['taskname'] = 'plotuv'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['field'] = field = myf['field']
            myparams['antenna'] = antenna = myf['antenna']
            myparams['spw'] = spw = myf['spw']
            myparams['observation'] = observation = myf['observation']
            myparams['array'] = array = myf['array']
            myparams['maxnpts'] = maxnpts = myf['maxnpts']
            myparams['colors'] = colors = myf['colors']
            myparams['symb'] = symb = myf['symb']
            myparams['ncycles'] = ncycles = myf['ncycles']
            myparams['figfile'] = figfile = myf['figfile']

        if type(colors)==str: colors=[colors]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['field'] = field
        mytmp['antenna'] = antenna
        mytmp['spw'] = spw
        mytmp['observation'] = observation
        mytmp['array'] = array
        mytmp['maxnpts'] = maxnpts
        mytmp['colors'] = colors
        mytmp['symb'] = symb
        mytmp['ncycles'] = ncycles
        mytmp['figfile'] = figfile
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'plotuv.xml')

        casalog.origin('plotuv')
        if not trec.has_key('plotuv') or not casac.utils().verify(mytmp, trec['plotuv']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: plotuv           #####')
          casalog.post('')
          result = plotuv(vis, field, antenna, spw, observation, array, maxnpts, colors, symb, ncycles, figfile)
          casalog.post('')
          casalog.post('##### End Task: plotuv           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('plotuv', 'plotuv.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'plotuv'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('plotuv', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['vis']  = ''
        a['field']  = ''
        a['antenna']  = ''
        a['spw']  = ''
        a['observation']  = ''
        a['array']  = ''
        a['maxnpts']  = 100000
        a['colors']  = ['r', 'y', 'g', 'b']
        a['symb']  = ','
        a['ncycles']  = 1
        a['figfile']  = ''


### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='plotuv', subkey=None):
        desc={'plotuv': 'Plot the baseline distribution',
               'vis': 'Name of input visibility file (MS)',
               'field': 'Select field using ID(s) or name(s)',
               'antenna': 'Select data based on antenna/baseline',
               'spw': 'Select spectral window/channels',
               'observation': 'Select by observation ID(s)',
               'array': 'Select (sub)array(s) by array ID number',
               'maxnpts': 'Maximum number of points per plot.',
               'colors': 'a list of matplotlib color codes',
               'symb': 'A matplotlib plot symbol code',
               'ncycles': 'How many times to cycle through colors per plot.',
               'figfile': 'Save the plotted figure(s) using this name',

              }

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['field']  = ''
        a['antenna']  = ''
        a['spw']  = ''
        a['observation']  = ''
        a['array']  = ''
        a['maxnpts']  = 100000
        a['colors']  = ['r', 'y', 'g', 'b']
        a['symb']  = ','
        a['ncycles']  = 1
        a['figfile']  = ''

        if a.has_key(paramname) :
	      return a[paramname]
plotuv_pg = plotuv_pg_()
