#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
from  casac import *
import string
from taskinit import casalog
#from taskmanager import tm
import task_sdflagmanager
def sdflagmanager(infile='', mode='list', versionname='', oldname='', comment='', merge='replace'):

        """ASAP SD task to manipulate flag version files
Keyword arguments:
infile -- name of input SD dataset
        default: ''
        example: infile='ngc5921.asap'
mode -- Flag version operation
        default: 'list';   to list existing flagtables
                 'save'    to copy flag columns of infile to a flag file
                 'restore' to place the specified flag file into infile
                 'delete'  to delete the specified flag file
                 'rename'  to rename the specified flag file
    >>> mode expandable parameters             
        versionname -- Flag version name
                default: none; example: versionname='original_data'
                No imbedded blanks in the versionname
        comment -- Short description of a versionname, when mode is 'save' 
                   or 'rename'
                default: ''
                example: comment='Clip above 1.85'
                         comment = versionname
        oldname -- When mode='rename', the flag file to rename
        merge -- merge operation
                options: 'or','and', but not recommended for now.
  
        """

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['infile'] = infile
        mytmp['mode'] = mode
        mytmp['versionname'] = versionname
        mytmp['oldname'] = oldname
        mytmp['comment'] = comment
        mytmp['merge'] = merge
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'sdflagmanager.xml')

        casalog.origin('sdflagmanager')
        if trec.has_key('sdflagmanager') and casac.utils().verify(mytmp, trec['sdflagmanager']) :
	    result = task_sdflagmanager.sdflagmanager(infile, mode, versionname, oldname, comment, merge)

	else :
	  result = False
        return result
