#
# This file was generated using xslt from its XML file
#
# Copyright 2014, Associated Universities Inc., Washington DC
#
import sys
import os
#from casac import *
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from types import * 
from task_tclean import tclean
class tclean_cli_:
    __name__ = "tclean"
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (tclean_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'vis':None, 'field':None, 'spw':None, 'timerange':None, 'uvrange':None, 'antenna':None, 'scan':None, 'observation':None, 'intent':None, 'datacolumn':None, 'imagename':None, 'imsize':None, 'cell':None, 'phasecenter':None, 'stokes':None, 'projection':None, 'startmodel':None, 'outlierfile':None, 'overwrite':None, 'specmode':None, 'reffreq':None, 'nchan':None, 'start':None, 'width':None, 'outframe':None, 'veltype':None, 'restfreq':None, 'sysvel':None, 'sysvelframe':None, 'interpolation':None, 'gridmode':None, 'facets':None, 'wprojplanes':None, 'aterm':None, 'psterm':None, 'wbawp':None, 'conjbeams':None, 'cfcache':None, 'computepastep':None, 'rotatepastep':None, 'pblimit':None, 'normtype':None, 'weighting':None, 'robust':None, 'npixels':None, 'uvtaper':None, 'deconvolver':None, 'scales':None, 'ntaylorterms':None, 'restoringbeam':None, 'niter':None, 'gain':None, 'threshold':None, 'cycleniter':None, 'cyclefactor':None, 'minpsffraction':None, 'maxpsffraction':None, 'interactive':None, 'mask':None, 'savemodel':None, 'recalcres':None, 'recalcpsf':None, 'parallel':None, }


    def result(self, key=None):
	    #### and add any that have completed...
	    return None


    def __call__(self, vis=None, field=None, spw=None, timerange=None, uvrange=None, antenna=None, scan=None, observation=None, intent=None, datacolumn=None, imagename=None, imsize=None, cell=None, phasecenter=None, stokes=None, projection=None, startmodel=None, outlierfile=None, overwrite=None, specmode=None, reffreq=None, nchan=None, start=None, width=None, outframe=None, veltype=None, restfreq=None, sysvel=None, sysvelframe=None, interpolation=None, gridmode=None, facets=None, wprojplanes=None, aterm=None, psterm=None, wbawp=None, conjbeams=None, cfcache=None, computepastep=None, rotatepastep=None, pblimit=None, normtype=None, weighting=None, robust=None, npixels=None, uvtaper=None, deconvolver=None, scales=None, ntaylorterms=None, restoringbeam=None, niter=None, gain=None, threshold=None, cycleniter=None, cyclefactor=None, minpsffraction=None, maxpsffraction=None, interactive=None, mask=None, savemodel=None, recalcres=None, recalcpsf=None, parallel=None, ):

        """Interferometric image Reconstruction

	Detailed Description: 


      This new task is a refactored version of the clean task, 
      with changes in the organization of input parameters,
      iteration controls, usability of some algorithms and modes,  
      log messages, and parallelization options.
      
      This task is under active development and is NOT READY 
      for general use in casapy 4.4.

      However if you are curious, please feel free to explore it
      but please understand that some modes are incomplete,
      user support will not be provided, and bug reports will not 
      be responded to at this stage. 

      Your patience is appreciated. 


	Arguments :
		vis:	Name of input visibility file(s)
		   Default Value: 

		field:	field(s) to select
		   Default Value: 

		spw:	spw(s) to select
		   Default Value: 

		timerange:	Range of time to select from data
		   Default Value: 

		uvrange:	Select data within uvrange 
		   Default Value: 

		antenna:	Select data based on antenna/baseline
		   Default Value: 

		scan:	Scan number range
		   Default Value: 

		observation:	Observation ID range
		   Default Value: 

		intent:	Scan Intent(s)
		   Default Value: 

		datacolumn:	data or observed, corrected
		   Default Value: corrected

		imagename:	Pre-name of output images
		   Default Value: 

		imsize:	Number of pixels
		   Default Value: 100

		cell:	Cell size
		   Default Value: "1arcsec"

		phasecenter:	Phase center of the image
		   Default Value: 

		stokes:	Stokes Planes to make
		   Default Value: I

		projection:	Coordinate projection (SIN, HPX) 
		   Default Value: SIN

		startmodel:	Name of starting model image 
		   Default Value: 

		outlierfile:	Name of outlier-field image definitions
		   Default Value: 

		overwrite:	True : Re-use existing images. False : Increment imagename
		   Default Value: True

		specmode:	Spectral definition mode (mfs,cube,cubesrc,cubedata)
		   Default Value: mfs

		reffreq:	Reference frequency
		   Default Value: 

		nchan:	Number of channels in the output image
		   Default Value: -1

		start:	First channel (e.g. chan=3,chan=\'1.1GHz\',chan=\'15343km/s\')
		   Default Value: 

		width:	Channel width (e.g. width=2,width=\'0.1MHz\',width=\'10km/s\')
		   Default Value: 

		outframe:	Spectral reference frame in which to interpret \'start\' and \'width\'
		   Default Value: LSRK

		veltype:	Velocity type (radio, z, ratio, beta, gamma, optical)
		   Default Value: radio

		restfreq:	List of rest frequencies
		   Default Value: 

		sysvel:	Systemic velocity (for mode=cubesrc) 
		   Default Value: 

		sysvelframe:	Spectral frame in which sysvel is specified (for mode=cubesrc only)
		   Default Value: 

		interpolation:	Spectral interpolation (nearest,linear,cubic)
		   Default Value: linear
		   Allowed Values:
				nearest
				linear
				cubic

		gridmode:	Gridding options (standard, widefield, mosaic, imagemosaic, awproject)
		   Default Value: standard
		   Allowed Values:
				standard
				widefield
				mosaic
				imagemosaic
				awproject

		facets:	Number of facets on a side
		   Default Value: 1

		wprojplanes:	Number of w-planes for convolution function calculation
		   Default Value: 1

		aterm:	Use aperture illumination function during gridding
		   Default Value: True

		psterm:	Use prolate spheroidal during gridding
		   Default Value: False

		wbawp:	Use wideband A-terms
		   Default Value: True

		conjbeams:	Use conjugate frequency for wideband A-terms 
		   Default Value: True

		cfcache:	Convolution function cache directory name
		   Default Value: 

		computepastep:	At what parallactic angle interval to recompute AIFs (deg) 
		   Default Value: 360.0

		rotatepastep:	At what parallactic angle interval to rotate nearest AIF (deg) 
		   Default Value: 5.0

		pblimit:	PB gain level at which to cut off image calculations  
		   Default Value: 0.01

		normtype:	Normalization type (flatnoise, flatsky) 
		   Default Value: flatnoise

		weighting:	Weighting scheme (natural,uniform,briggs)
		   Default Value: natural

		robust:	Robustness parameter
		   Default Value: 0.5

		npixels:	Number of pixels to determine uv-cell size (0 : -/+ 3 pixels)
		   Default Value: 0

		uvtaper:	uv-taper on outer baselines in uv-plane
		   Default Value: 
	      
	    

		deconvolver:	Name of minor cycle algorithm
		   Default Value: clark
		   Allowed Values:
				hogbom
				clark
				clarkstokes
				multiscale
				mtmfs
				mem
				aasp

		scales:	List of scale sizes (in pixels) for multi-scale cleaning
		   Default Value: 

		ntaylorterms:	Number of Taylor coefficients in the spectral model
		   Default Value: 2

		restoringbeam:	Restoring beam shape to use. Default is the PSF main lobe width. 
		   Default Value: 

		niter:	Maximum number of iterations
		   Default Value: 500

		gain:	Loop gain
		   Default Value: 0.1

		threshold:	Stopping threshold (number, in units of Jy)
		   Default Value: 0.0

		cycleniter:	Maximum number of minor-cycle iterations before triggering a major cycle
		   Default Value: -1

		cyclefactor:	Scaling on PSF sidelobe level to compute the minor-cycle stopping threshold.
		   Default Value: 1.0

		minpsffraction:	PSF fraction that marks the max depth of cleaning in the minor cycle 
		   Default Value: 0.05

		maxpsffraction:	PSF fraction that marks the minimum depth of cleaning in the minor cycle 
		   Default Value: 0.8

		interactive:	True to be able to modify masks and parameters at runtime
		   Default Value: False

		mask:	Mask string (image name or region file or region string)
		   Default Value: 

		savemodel:	Options to save model at the end (none, virtual, modelcolumn)
		   Default Value: none

		recalcres:	(Re)calculate residual image
		   Default Value: True

		recalcpsf:	Recalculate PSF
		   Default Value: True

		parallel:	Run major cycles in parallel
		   Default Value: False

	Returns: void

	Example :


      This new task is under active development and is not ready 
      for general use in casapy 4.4. 

      However if you are curious, please feel free to explore it
      but please understand that some modes are incomplete,
      user support will not be provided, and bug reports will not 
      be responded to at this stage. 

      Your patience is appreciated. 

 
        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
	#casac = self.__globals__['casac']
	casalog = self.__globals__['casalog']
	#casalog = casac.casac.logsink()
        self.__globals__['__last_task'] = 'tclean'
        self.__globals__['taskname'] = 'tclean'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
        if type(self.__call__.func_defaults) is NoneType:
            function_signature_defaults={}
	else:
	    function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames[1:],self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')
	 
        else :
            print ''

            myparams['vis'] = vis = self.parameters['vis']
            myparams['field'] = field = self.parameters['field']
            myparams['spw'] = spw = self.parameters['spw']
            myparams['timerange'] = timerange = self.parameters['timerange']
            myparams['uvrange'] = uvrange = self.parameters['uvrange']
            myparams['antenna'] = antenna = self.parameters['antenna']
            myparams['scan'] = scan = self.parameters['scan']
            myparams['observation'] = observation = self.parameters['observation']
            myparams['intent'] = intent = self.parameters['intent']
            myparams['datacolumn'] = datacolumn = self.parameters['datacolumn']
            myparams['imagename'] = imagename = self.parameters['imagename']
            myparams['imsize'] = imsize = self.parameters['imsize']
            myparams['cell'] = cell = self.parameters['cell']
            myparams['phasecenter'] = phasecenter = self.parameters['phasecenter']
            myparams['stokes'] = stokes = self.parameters['stokes']
            myparams['projection'] = projection = self.parameters['projection']
            myparams['startmodel'] = startmodel = self.parameters['startmodel']
            myparams['outlierfile'] = outlierfile = self.parameters['outlierfile']
            myparams['overwrite'] = overwrite = self.parameters['overwrite']
            myparams['specmode'] = specmode = self.parameters['specmode']
            myparams['reffreq'] = reffreq = self.parameters['reffreq']
            myparams['nchan'] = nchan = self.parameters['nchan']
            myparams['start'] = start = self.parameters['start']
            myparams['width'] = width = self.parameters['width']
            myparams['outframe'] = outframe = self.parameters['outframe']
            myparams['veltype'] = veltype = self.parameters['veltype']
            myparams['restfreq'] = restfreq = self.parameters['restfreq']
            myparams['sysvel'] = sysvel = self.parameters['sysvel']
            myparams['sysvelframe'] = sysvelframe = self.parameters['sysvelframe']
            myparams['interpolation'] = interpolation = self.parameters['interpolation']
            myparams['gridmode'] = gridmode = self.parameters['gridmode']
            myparams['facets'] = facets = self.parameters['facets']
            myparams['wprojplanes'] = wprojplanes = self.parameters['wprojplanes']
            myparams['aterm'] = aterm = self.parameters['aterm']
            myparams['psterm'] = psterm = self.parameters['psterm']
            myparams['wbawp'] = wbawp = self.parameters['wbawp']
            myparams['conjbeams'] = conjbeams = self.parameters['conjbeams']
            myparams['cfcache'] = cfcache = self.parameters['cfcache']
            myparams['computepastep'] = computepastep = self.parameters['computepastep']
            myparams['rotatepastep'] = rotatepastep = self.parameters['rotatepastep']
            myparams['pblimit'] = pblimit = self.parameters['pblimit']
            myparams['normtype'] = normtype = self.parameters['normtype']
            myparams['weighting'] = weighting = self.parameters['weighting']
            myparams['robust'] = robust = self.parameters['robust']
            myparams['npixels'] = npixels = self.parameters['npixels']
            myparams['uvtaper'] = uvtaper = self.parameters['uvtaper']
            myparams['deconvolver'] = deconvolver = self.parameters['deconvolver']
            myparams['scales'] = scales = self.parameters['scales']
            myparams['ntaylorterms'] = ntaylorterms = self.parameters['ntaylorterms']
            myparams['restoringbeam'] = restoringbeam = self.parameters['restoringbeam']
            myparams['niter'] = niter = self.parameters['niter']
            myparams['gain'] = gain = self.parameters['gain']
            myparams['threshold'] = threshold = self.parameters['threshold']
            myparams['cycleniter'] = cycleniter = self.parameters['cycleniter']
            myparams['cyclefactor'] = cyclefactor = self.parameters['cyclefactor']
            myparams['minpsffraction'] = minpsffraction = self.parameters['minpsffraction']
            myparams['maxpsffraction'] = maxpsffraction = self.parameters['maxpsffraction']
            myparams['interactive'] = interactive = self.parameters['interactive']
            myparams['mask'] = mask = self.parameters['mask']
            myparams['savemodel'] = savemodel = self.parameters['savemodel']
            myparams['recalcres'] = recalcres = self.parameters['recalcres']
            myparams['recalcpsf'] = recalcpsf = self.parameters['recalcpsf']
            myparams['parallel'] = parallel = self.parameters['parallel']

        if type(uvtaper)==str: uvtaper=[uvtaper]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['field'] = field
        mytmp['spw'] = spw
        mytmp['timerange'] = timerange
        mytmp['uvrange'] = uvrange
        mytmp['antenna'] = antenna
        mytmp['scan'] = scan
        mytmp['observation'] = observation
        mytmp['intent'] = intent
        mytmp['datacolumn'] = datacolumn
        mytmp['imagename'] = imagename
        mytmp['imsize'] = imsize
        mytmp['cell'] = cell
        mytmp['phasecenter'] = phasecenter
        mytmp['stokes'] = stokes
        mytmp['projection'] = projection
        mytmp['startmodel'] = startmodel
        mytmp['outlierfile'] = outlierfile
        mytmp['overwrite'] = overwrite
        mytmp['specmode'] = specmode
        mytmp['reffreq'] = reffreq
        mytmp['nchan'] = nchan
        mytmp['start'] = start
        mytmp['width'] = width
        mytmp['outframe'] = outframe
        mytmp['veltype'] = veltype
        mytmp['restfreq'] = restfreq
        mytmp['sysvel'] = sysvel
        mytmp['sysvelframe'] = sysvelframe
        mytmp['interpolation'] = interpolation
        mytmp['gridmode'] = gridmode
        mytmp['facets'] = facets
        mytmp['wprojplanes'] = wprojplanes
        mytmp['aterm'] = aterm
        mytmp['psterm'] = psterm
        mytmp['wbawp'] = wbawp
        mytmp['conjbeams'] = conjbeams
        mytmp['cfcache'] = cfcache
        mytmp['computepastep'] = computepastep
        mytmp['rotatepastep'] = rotatepastep
        mytmp['pblimit'] = pblimit
        mytmp['normtype'] = normtype
        mytmp['weighting'] = weighting
        mytmp['robust'] = robust
        mytmp['npixels'] = npixels
        mytmp['uvtaper'] = uvtaper
        mytmp['deconvolver'] = deconvolver
        mytmp['scales'] = scales
        mytmp['ntaylorterms'] = ntaylorterms
        mytmp['restoringbeam'] = restoringbeam
        mytmp['niter'] = niter
        mytmp['gain'] = gain
        mytmp['threshold'] = threshold
        mytmp['cycleniter'] = cycleniter
        mytmp['cyclefactor'] = cyclefactor
        mytmp['minpsffraction'] = minpsffraction
        mytmp['maxpsffraction'] = maxpsffraction
        mytmp['interactive'] = interactive
        mytmp['mask'] = mask
        mytmp['savemodel'] = savemodel
        mytmp['recalcres'] = recalcres
        mytmp['recalcpsf'] = recalcpsf
        mytmp['parallel'] = parallel
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.casac.utils().torecord(pathname+'tclean.xml')

        casalog.origin('tclean')
	try :
          #if not trec.has_key('tclean') or not casac.casac.utils().verify(mytmp, trec['tclean']) :
	    #return False

          casac.casac.utils().verify(mytmp, trec['tclean'], True)
          scriptstr=['']
          saveinputs = self.__globals__['saveinputs']
          if type(self.__call__.func_defaults) is NoneType:
              saveinputs=''
          else:
              saveinputs('tclean', 'tclean.last', myparams, self.__globals__,scriptstr=scriptstr)
          tname = 'tclean'
          spaces = ' '*(18-len(tname))
          casalog.post('\n##########################################'+
                       '\n##### Begin Task: ' + tname + spaces + ' #####')
          if type(self.__call__.func_defaults) is NoneType:
              casalog.post(scriptstr[0]+'\n', 'INFO')
          else :
              casalog.post(scriptstr[1][1:]+'\n', 'INFO')
          result = tclean(vis, field, spw, timerange, uvrange, antenna, scan, observation, intent, datacolumn, imagename, imsize, cell, phasecenter, stokes, projection, startmodel, outlierfile, overwrite, specmode, reffreq, nchan, start, width, outframe, veltype, restfreq, sysvel, sysvelframe, interpolation, gridmode, facets, wprojplanes, aterm, psterm, wbawp, conjbeams, cfcache, computepastep, rotatepastep, pblimit, normtype, weighting, robust, npixels, uvtaper, deconvolver, scales, ntaylorterms, restoringbeam, niter, gain, threshold, cycleniter, cyclefactor, minpsffraction, maxpsffraction, interactive, mask, savemodel, recalcres, recalcpsf, parallel)
          casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####'+
                       '\n##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             #print '**** Error **** ',instance
	     tname = 'tclean'
             casalog.post('An error occurred running task '+tname+'.', 'ERROR')
             pass

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('tclean', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['vis']  = ''
        a['imagename']  = ''
        a['outlierfile']  = ''
        a['overwrite']  = True
        a['specmode']  = 'mfs'
        a['gridmode']  = 'standard'
        a['weighting']  = 'natural'
        a['deconvolver']  = 'clark'
        a['niter']  = 500
        a['savemodel']  = 'none'
        a['recalcres']  = True
        a['recalcpsf']  = True
        a['parallel']  = False

        a['vis'] = {
                    0:odict([{'notvalue':''}, {'field':""}, {'spw':""}, {'timerange':""}, {'uvrange':""}, {'antenna':""}, {'scan':""}, {'observation':""}, {'intent':""}, {'datacolumn':"corrected"}])}
        a['imagename'] = {
                    0:odict([{'notvalue':''}, {'imsize':100}, {'cell':"1arcsec"}, {'phasecenter':""}, {'stokes':"I"}, {'projection':"SIN"}, {'startmodel':""}])}
        a['specmode'] = {
                    0:odict([{'value':'mfs'}, {'reffreq':""}]), 
                    1:odict([{'value':'cube'}, {'nchan':-1}, {'start':""}, {'width':""}, {'outframe':""}, {'veltype':"radio"}, {'restfreq':[]}, {'interpolation':"linear"}]), 
                    2:odict([{'value':'cubesrc'}, {'nchan':-1}, {'start':""}, {'width':""}, {'outframe':""}, {'veltype':"radio"}, {'restfreq':[]}, {'sysvel':""}, {'sysvelframe':""}, {'interpolation':"linear"}]), 
                    3:odict([{'value':'cubedata'}, {'nchan':-1}, {'start':""}, {'width':""}, {'veltype':"radio"}, {'restfreq':[]}, {'interpolation':"linear"}])}
        a['gridmode'] = {
                    0:{'value':'standard'}, 
                    1:odict([{'value':'widefield'}, {'wprojplanes':1}, {'facets':1}]), 
                    2:odict([{'value':'mosaic'}, {'pblimit':0.01}, {'normtype':"flatnoise"}]), 
                    3:odict([{'value':'imagemosaic'}, {'wprojplanes':1}, {'pblimit':0.01}, {'normtype':"flatnoise"}]), 
                    4:odict([{'value':'awproject'}, {'wprojplanes':1}, {'pblimit':0.01}, {'normtype':"flatnoise"}, {'psterm':False}, {'cfcache':""}, {'computepastep':360.0}, {'rotatepastep':5.0}, {'wbawp':False}, {'conjbeams':False}])}
        a['weighting'] = {
                    0:odict([{'value':'natural'}, {'uvtaper':[]}]), 
                    1:{'value':'uniform'}, 
                    2:odict([{'value':'briggs'}, {'robust':0.5}, {'npixels':0}, {'uvtaper':[]}])}
        a['deconvolver'] = {
                    0:odict([{'value':'clark'}, {'restoringbeam':[]}]), 
                    1:odict([{'value':'hogbom'}, {'restoringbeam':[]}]), 
                    2:odict([{'value':'multiscale'}, {'scales':[]}, {'restoringbeam':[]}]), 
                    3:odict([{'value':'mtmfs'}, {'scales':[]}, {'ntaylorterms':2}, {'restoringbeam':[]}]), 
                    4:odict([{'value':'aasp'}, {'restoringbeam':[]}])}
        a['niter'] = {
                    0:odict([{'notvalue':0}, {'gain':0.1}, {'threshold':0.0}, {'cycleniter':-1}, {'cyclefactor':1.0}, {'minpsffraction':0.05}, {'maxpsffraction':0.8}, {'interactive':False}, {'mask':""}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals
#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value
#
#
    def description(self, key='tclean', subkey=None):
        desc={'tclean': 'Interferometric image Reconstruction',
               'vis': 'Name of input visibility file(s)',
               'field': 'field(s) to select',
               'spw': 'spw(s) to select',
               'timerange': 'Range of time to select from data',
               'uvrange': 'Select data within uvrange ',
               'antenna': 'Select data based on antenna/baseline',
               'scan': 'Scan number range',
               'observation': 'Observation ID range',
               'intent': 'Scan Intent(s)',
               'datacolumn': 'data or observed, corrected',
               'imagename': 'Pre-name of output images',
               'imsize': 'Number of pixels',
               'cell': 'Cell size',
               'phasecenter': 'Phase center of the image',
               'stokes': 'Stokes Planes to make',
               'projection': 'Coordinate projection (SIN, HPX) ',
               'startmodel': 'Name of starting model image ',
               'outlierfile': 'Name of outlier-field image definitions',
               'overwrite': 'True : Re-use existing images. False : Increment imagename',
               'specmode': 'Spectral definition mode (mfs,cube,cubesrc,cubedata)',
               'reffreq': 'Reference frequency',
               'nchan': 'Number of channels in the output image',
               'start': 'First channel (e.g. chan=3,chan=\'1.1GHz\',chan=\'15343km/s\')',
               'width': 'Channel width (e.g. width=2,width=\'0.1MHz\',width=\'10km/s\')',
               'outframe': 'Spectral reference frame in which to interpret \'start\' and \'width\'',
               'veltype': 'Velocity type (radio, z, ratio, beta, gamma, optical)',
               'restfreq': 'List of rest frequencies',
               'sysvel': 'Systemic velocity (for mode=cubesrc) ',
               'sysvelframe': 'Spectral frame in which sysvel is specified (for mode=cubesrc only)',
               'interpolation': 'Spectral interpolation (nearest,linear,cubic)',
               'gridmode': 'Gridding options (standard, widefield, mosaic, imagemosaic, awproject)',
               'facets': 'Number of facets on a side',
               'wprojplanes': 'Number of w-planes for convolution function calculation',
               'aterm': 'Use aperture illumination function during gridding',
               'psterm': 'Use prolate spheroidal during gridding',
               'wbawp': 'Use wideband A-terms',
               'conjbeams': 'Use conjugate frequency for wideband A-terms ',
               'cfcache': 'Convolution function cache directory name',
               'computepastep': 'At what parallactic angle interval to recompute AIFs (deg) ',
               'rotatepastep': 'At what parallactic angle interval to rotate nearest AIF (deg) ',
               'pblimit': 'PB gain level at which to cut off image calculations  ',
               'normtype': 'Normalization type (flatnoise, flatsky) ',
               'weighting': 'Weighting scheme (natural,uniform,briggs)',
               'robust': 'Robustness parameter',
               'npixels': 'Number of pixels to determine uv-cell size (0 : -/+ 3 pixels)',
               'uvtaper': 'uv-taper on outer baselines in uv-plane',
               'deconvolver': 'Name of minor cycle algorithm',
               'scales': 'List of scale sizes (in pixels) for multi-scale cleaning',
               'ntaylorterms': 'Number of Taylor coefficients in the spectral model',
               'restoringbeam': 'Restoring beam shape to use. Default is the PSF main lobe width. ',
               'niter': 'Maximum number of iterations',
               'gain': 'Loop gain',
               'threshold': 'Stopping threshold (number, in units of Jy)',
               'cycleniter': 'Maximum number of minor-cycle iterations before triggering a major cycle',
               'cyclefactor': 'Scaling on PSF sidelobe level to compute the minor-cycle stopping threshold.',
               'minpsffraction': 'PSF fraction that marks the max depth of cleaning in the minor cycle ',
               'maxpsffraction': 'PSF fraction that marks the minimum depth of cleaning in the minor cycle ',
               'interactive': 'True to be able to modify masks and parameters at runtime',
               'mask': 'Mask string (image name or region file or region string)',
               'savemodel': 'Options to save model at the end (none, virtual, modelcolumn)',
               'recalcres': '(Re)calculate residual image',
               'recalcpsf': 'Recalculate PSF',
               'parallel': 'Run major cycles in parallel',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['field']  = ''
        a['spw']  = ''
        a['timerange']  = ''
        a['uvrange']  = ''
        a['antenna']  = ''
        a['scan']  = ''
        a['observation']  = ''
        a['intent']  = ''
        a['datacolumn']  = 'corrected'
        a['imagename']  = ''
        a['imsize']  = [100]
        a['cell']  = ["1arcsec"]
        a['phasecenter']  = ''
        a['stokes']  = 'I'
        a['projection']  = 'SIN'
        a['startmodel']  = ''
        a['outlierfile']  = ''
        a['overwrite']  = True
        a['specmode']  = 'mfs'
        a['reffreq']  = ''
        a['nchan']  = -1
        a['start']  = ''
        a['width']  = ''
        a['outframe']  = 'LSRK'
        a['veltype']  = 'radio'
        a['restfreq']  = []
        a['sysvel']  = ''
        a['sysvelframe']  = ''
        a['interpolation']  = 'linear'
        a['gridmode']  = 'standard'
        a['facets']  = 1
        a['wprojplanes']  = 1
        a['aterm']  = True
        a['psterm']  = False
        a['wbawp']  = True
        a['conjbeams']  = True
        a['cfcache']  = ''
        a['computepastep']  = 360.0
        a['rotatepastep']  = 5.0
        a['pblimit']  = 0.01
        a['normtype']  = 'flatnoise'
        a['weighting']  = 'natural'
        a['robust']  = 0.5
        a['npixels']  = 0
        a['uvtaper']  = ['']
        a['deconvolver']  = 'clark'
        a['scales']  = []
        a['ntaylorterms']  = 2
        a['restoringbeam']  = []
        a['niter']  = 500
        a['gain']  = 0.1
        a['threshold']  = 0.0
        a['cycleniter']  = -1
        a['cyclefactor']  = 1.0
        a['minpsffraction']  = 0.05
        a['maxpsffraction']  = 0.8
        a['interactive']  = False
        a['mask']  = ''
        a['savemodel']  = 'none'
        a['recalcres']  = True
        a['recalcpsf']  = True
        a['parallel']  = False

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if self.parameters['vis']  != '':
            a['field'] = ""
            a['spw'] = ""
            a['timerange'] = ""
            a['uvrange'] = ""
            a['antenna'] = ""
            a['scan'] = ""
            a['observation'] = ""
            a['intent'] = ""
            a['datacolumn'] = "corrected"

        if self.parameters['imagename']  != '':
            a['imsize'] = 100
            a['cell'] = "1arcsec"
            a['phasecenter'] = ""
            a['stokes'] = "I"
            a['projection'] = "SIN"
            a['startmodel'] = ""

        if self.parameters['specmode']  == 'mfs':
            a['reffreq'] = ""

        if self.parameters['specmode']  == 'cube':
            a['nchan'] = -1
            a['start'] = ""
            a['width'] = ""
            a['outframe'] = ""
            a['veltype'] = "radio"
            a['restfreq'] = []
            a['interpolation'] = "linear"

        if self.parameters['specmode']  == 'cubesrc':
            a['nchan'] = -1
            a['start'] = ""
            a['width'] = ""
            a['outframe'] = ""
            a['veltype'] = "radio"
            a['restfreq'] = []
            a['sysvel'] = ""
            a['sysvelframe'] = ""
            a['interpolation'] = "linear"

        if self.parameters['specmode']  == 'cubedata':
            a['nchan'] = -1
            a['start'] = ""
            a['width'] = ""
            a['veltype'] = "radio"
            a['restfreq'] = []
            a['interpolation'] = "linear"

        if self.parameters['gridmode']  == 'widefield':
            a['wprojplanes'] = 1
            a['facets'] = 1

        if self.parameters['gridmode']  == 'mosaic':
            a['pblimit'] = 0.01
            a['normtype'] = "flatnoise"

        if self.parameters['gridmode']  == 'imagemosaic':
            a['wprojplanes'] = 1
            a['pblimit'] = 0.01
            a['normtype'] = "flatnoise"

        if self.parameters['gridmode']  == 'awproject':
            a['wprojplanes'] = 1
            a['pblimit'] = 0.01
            a['normtype'] = "flatnoise"
            a['psterm'] = False
            a['cfcache'] = ""
            a['computepastep'] = 360.0
            a['rotatepastep'] = 5.0
            a['wbawp'] = False
            a['conjbeams'] = False

        if self.parameters['weighting']  == 'natural':
            a['uvtaper'] = []

        if self.parameters['weighting']  == 'briggs':
            a['robust'] = 0.5
            a['npixels'] = 0
            a['uvtaper'] = []

        if self.parameters['deconvolver']  == 'clark':
            a['restoringbeam'] = []

        if self.parameters['deconvolver']  == 'hogbom':
            a['restoringbeam'] = []

        if self.parameters['deconvolver']  == 'multiscale':
            a['scales'] = []
            a['restoringbeam'] = []

        if self.parameters['deconvolver']  == 'mtmfs':
            a['scales'] = []
            a['ntaylorterms'] = 2
            a['restoringbeam'] = []

        if self.parameters['deconvolver']  == 'aasp':
            a['restoringbeam'] = []

        if self.parameters['niter']  != 0:
            a['gain'] = 0.1
            a['threshold'] = 0.0
            a['cycleniter'] = -1
            a['cyclefactor'] = 1.0
            a['minpsffraction'] = 0.05
            a['maxpsffraction'] = 0.8
            a['interactive'] = False
            a['mask'] = ""

        if a.has_key(paramname) :
	      return a[paramname]
tclean_cli = tclean_cli_()
