#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
from casac import *
import string
import time
import inspect
import gc
import numpy
from odict import odict
from task_wvrgcal import wvrgcal
from task_wvrgcal import casalog

class wvrgcal_pg_:
    __name__ = "wvrgcal"

    def __init__(self) :
       self.__bases__ = (wvrgcal_pg_,)
       self.__doc__ = self.__call__.__doc__


    def __call__(self, vis=None,caltable=None,toffset=None,segsource=None,sourceflag=None,tie=None,nsol=None,disperse=None,wvrflag=None,statfield=None,statsource=None,smooth=None,scale=None,spw=None,wvrspw=None,reversespw=None,cont=None,maxdistm=None,minnumants=None,mingoodfrac=None,usefieldtab=None,refant=None,):

        """Generate a gain table based on Water Vapour Radiometer data

   wvrgcal(vis='uid___A002_X1d54a1_X5.ms', caltable='cal-wvr-uid___A002_X1d54a1_X5.W',
           toffset=-1, segsource=True, tie=['Titan,1037-295,NGC3256'], statsource='1037-295')

  
        """
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        myf['__last_task'] = 'wvrgcal'
        myf['taskname'] = 'wvrgcal'
        ###
        myf['update_params'](func=myf['taskname'],printtext=False)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True
                        #myf[key]=keyVal

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
		      exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')

	else :
            uselessvariable = None 
            myparams['vis'] = vis = myf['vis']
            myparams['caltable'] = caltable = myf['caltable']
            myparams['toffset'] = toffset = myf['toffset']
            myparams['segsource'] = segsource = myf['segsource']
            myparams['sourceflag'] = sourceflag = myf['sourceflag']
            myparams['tie'] = tie = myf['tie']
            myparams['nsol'] = nsol = myf['nsol']
            myparams['disperse'] = disperse = myf['disperse']
            myparams['wvrflag'] = wvrflag = myf['wvrflag']
            myparams['statfield'] = statfield = myf['statfield']
            myparams['statsource'] = statsource = myf['statsource']
            myparams['smooth'] = smooth = myf['smooth']
            myparams['scale'] = scale = myf['scale']
            myparams['spw'] = spw = myf['spw']
            myparams['wvrspw'] = wvrspw = myf['wvrspw']
            myparams['reversespw'] = reversespw = myf['reversespw']
            myparams['cont'] = cont = myf['cont']
            myparams['maxdistm'] = maxdistm = myf['maxdistm']
            myparams['minnumants'] = minnumants = myf['minnumants']
            myparams['mingoodfrac'] = mingoodfrac = myf['mingoodfrac']
            myparams['usefieldtab'] = usefieldtab = myf['usefieldtab']
            myparams['refant'] = refant = myf['refant']

        if type(sourceflag)==str: sourceflag=[sourceflag]
        if type(tie)==str: tie=[tie]
        if type(wvrflag)==str: wvrflag=[wvrflag]
        if type(spw)==int: spw=[spw]
        if type(wvrspw)==int: wvrspw=[wvrspw]
        if type(refant)==str: refant=[refant]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['caltable'] = caltable
        mytmp['toffset'] = toffset
        mytmp['segsource'] = segsource
        mytmp['sourceflag'] = sourceflag
        mytmp['tie'] = tie
        mytmp['nsol'] = nsol
        mytmp['disperse'] = disperse
        mytmp['wvrflag'] = wvrflag
        mytmp['statfield'] = statfield
        mytmp['statsource'] = statsource
        mytmp['smooth'] = smooth
        mytmp['scale'] = scale
        mytmp['spw'] = spw
        mytmp['wvrspw'] = wvrspw
        mytmp['reversespw'] = reversespw
        mytmp['cont'] = cont
        mytmp['maxdistm'] = maxdistm
        mytmp['minnumants'] = minnumants
        mytmp['mingoodfrac'] = mingoodfrac
        mytmp['usefieldtab'] = usefieldtab
        mytmp['refant'] = refant
	pathname='file:///'+os.environ.get('CASAPATH').split()[0]+'/xml/'
        trec = casac.utils().torecord(pathname+'wvrgcal.xml')

        casalog.origin('wvrgcal')
        if not trec.has_key('wvrgcal') or not casac.utils().verify(mytmp, trec['wvrgcal']) :
	    return False


	try :
          casalog.post('')
          casalog.post('##########################################')
          casalog.post('##### Begin Task: wvrgcal           #####')
          casalog.post('')
          result = wvrgcal(vis, caltable, toffset, segsource, sourceflag, tie, nsol, disperse, wvrflag, statfield, statsource, smooth, scale, spw, wvrspw, reversespw, cont, maxdistm, minnumants, mingoodfrac, usefieldtab, refant)
          casalog.post('')
          casalog.post('##### End Task: wvrgcal           #####')
          casalog.post('##########################################')


# saveinputs for individule engine has no use
# saveinputs should alos be removed from casa_in_py.py
#
#
#          saveinputs = myf['saveinputs']
#          saveinputs('wvrgcal', 'wvrgcal.last', myparams)
#
#
	except Exception, instance:
	  if(myf.has_key('__rethrow_casa_exceptions') and myf['__rethrow_casa_exceptions']) :
	     raise
	  else:
	     tname = 'wvrgcal'
	     casalog.post('An error occurred running task %s: %s' % (tname,instance), 'ERROR')
	     pass

        gc.collect()
        return result
#
#
##
#    def paramgui(self, useGlobals=True):
#        """
#        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
#        """
#        import paramgui
#
#        a=inspect.stack()
#        stacklevel=0
#        for k in range(len(a)):
#          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
#            stacklevel=k
#            break
#        myf = sys._getframe(stacklevel).f_globals
#
#        if useGlobals:
#            paramgui.setGlobals(myf)
#        else:
#            paramgui.setGlobals({})
#
#        paramgui.runTask('wvrgcal', myf['_ip'])
#        paramgui.setGlobals({})
#
#
#
#
    def defaults(self, param=None):
        a=inspect.stack()
        stacklevel=0
        for k in range(len(a)):
          if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
                stacklevel=k
                break
        myf=sys._getframe(stacklevel).f_globals
        a = odict()
        a['vis']  = ''
        a['caltable']  = ''
        a['toffset']  = 0
        a['segsource']  = True
        a['disperse']  = False
        a['wvrflag']  = ['']
        a['statfield']  = ''
        a['statsource']  = ''
        a['smooth']  = ''
        a['scale']  = 1.
        a['spw']  = []
        a['wvrspw']  = []
        a['reversespw']  = ''
        a['cont']  = False
        a['maxdistm']  = 500.
        a['minnumants']  = 2
        a['mingoodfrac']  = 0.8
        a['usefieldtab']  = False
        a['refant']  = ['']

        a['segsource'] = {
                    0:odict([{'value':True}, {'tie':[]}, {'sourceflag':[]}]), 
                    1:odict([{'value':False}, {'nsol':1}])}

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
	        if(a.has_key(param)):
		   #if(type(a[param]) == dict) :
		   #   return a[param][len(a[param])-1]['value']
	   	   #else :
		      return a[param]


#
#
    def check_params(self, param=None, value=None):
      a=inspect.stack() 
      stacklevel=0
      for k in range(len(a)):
        if (string.find(a[k][1], 'ipython console') > 0) or (string.find(a[k][1], '<string>') >= 0):
	    stacklevel=k
	    break
      myf=sys._getframe(stacklevel).f_globals

#      print 'param:', param, 'value:', value
      try :
         if str(type(value)) != "<type 'instance'>" :
            value0 = value
            value = myf['cu'].expandparam(param, value)
            matchtype = False
            if(type(value) == numpy.ndarray):
               if(type(value) == type(value0)):
                  myf[param] = value.tolist()
               else:
                  #print 'value:', value, 'value0:', value0
                  #print 'type(value):', type(value), 'type(value0):', type(value0)
                  myf[param] = value0
                  if type(value0) != list :
                     matchtype = True
            else :
               myf[param] = value
            value = myf['cu'].verifyparam({param:value})
            if matchtype:
               value = False
      except Exception, instance:
         #ignore the exception and just return it unchecked
         myf[param] = value
      return value

#
#
    def description(self, key='wvrgcal', subkey=None):
        desc={'wvrgcal': 'Generate a gain table based on Water Vapour Radiometer data',
               'vis': 'Name of input visibility file',
               'caltable': 'Name of output gain calibration table',
               'toffset': 'Time offset (sec) between interferometric and WVR data',
               'segsource': 'Do a new coefficient calculation for each source',
               'sourceflag': 'Regard the WVR data for these source(s) as bad and do not produce corrections for it (requires segsource=True)',
               'tie': 'Prioritise tieing the phase of these sources as well as possible (requires segsource=True)',
               'nsol': 'Number of solutions for phase correction coefficients (nsol>1 requires segsource=False)',
               'disperse': 'Apply correction for dispersion',
               'wvrflag': 'Regard the WVR data for these antenna(s) as bad and replace its data with interpolated values from neighbouring antennas',
               'statfield': 'Compute the statistics (Phase RMS, Disc) on this field only',
               'statsource': 'Compute the statistics (Phase RMS, Disc) on this source only',
               'smooth': 'Smooth calibration solution on the given timescale',
               'scale': 'Scale the entire phase correction by this factor',
               'spw': 'List of the spectral window IDs for which solutions should be saved into the caltable',
               'wvrspw': 'List of the spectral window IDs from which the WVR data should be taken',
               'reversespw': 'Reverse the sign of the correction for the listed SPWs (only needed for early ALMA data before Cycle 0)',
               'cont': 'Estimate the continuum (e.g., due to clouds) (experimental)',
               'maxdistm': 'maximum distance (m) of an antenna used for interpolation for a flagged antenna',
               'minnumants': 'minimum number of near antennas (up to 3) required for interpolation',
               'mingoodfrac': 'If the fraction of unflagged data for an antenna is below this value (0. to 1.), the antenna is flagged.',
               'usefieldtab': 'derive the antenna AZ/EL values from the FIELD rather than the POINTING table',
               'refant': 'use the WVR data from this antenna for calculating the dT/dL parameters (can give ranked list)',

              }

#
# Set subfields defaults if needed
#

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['caltable']  = ''
        a['toffset']  = 0
        a['segsource']  = True
        a['sourceflag']  = ['']
        a['tie']  = ['']
        a['nsol']  = 1
        a['disperse']  = False
        a['wvrflag']  = ['']
        a['statfield']  = ''
        a['statsource']  = ''
        a['smooth']  = ''
        a['scale']  = 1.
        a['spw']  = []
        a['wvrspw']  = []
        a['reversespw']  = ''
        a['cont']  = False
        a['maxdistm']  = 500.
        a['minnumants']  = 2
        a['mingoodfrac']  = 0.8
        a['usefieldtab']  = False
        a['refant']  = ['']

        if a.has_key(paramname) :
	      return a[paramname]
wvrgcal_pg = wvrgcal_pg_()
